static double dist_prev_l = 0.0;
static double dist_prev_r = 0.0;
static double err_prev_l  = 0.0;
static double err_prev_r  = 0.0;
static double err_sum_l   = 0.0;
static double err_sum_r   = 0.0;
static double vel_curr_l  = 0.0;
static double vel_curr_r  = 0.0;
static double vel_ref_l   = 0.0;
static double vel_ref_r   = 0.0;
static double vari = 0.0;
static double vari_s = 0.0;
static double varian = 0.0;
static double varian_s = 0.0;
static long count = 1;
static long counts = 1;


static double dist_prev_s = 0.0;
static double err_prev_s = 0.0;
static double err_sum_s   = 0.0;
static double vel_curr_s  = 0.0;
static double vel_ref_s   = 0.0;

void vel_ctrl_execute() {
  // PIDゲイン
  const double Kp = 0.5;//1.0; 
  const double Ki = 0.7;//1.0;
  const double Kd = 0.0;
  
  const double Kp_s = 0.5;//1.0; 
  const double Ki_s = 0.7;//1.0;
  const double Kd_s = 0.0;

  int pwm_l, pwm_r;
   int pwm_s;
  
 
  double dist_curr_l, dist_curr_r, err_curr_l, err_curr_r;
double dist_curr_s,  err_curr_s;
  // 速度 [cm/s] = 距離の差分 [cm] / (制御周期 [ms] / 1000)
  distance_get(&dist_curr_l, &dist_curr_r);
  vel_curr_l = (dist_curr_l - dist_prev_l) / T_CTRL * 1000.0;
  vel_curr_r = (dist_curr_r - dist_prev_r) / T_CTRL * 1000.0;
  
   distance_get_s(&dist_curr_s);
  vel_curr_s= (dist_curr_s - dist_prev_s) / T_CTRL * 1000.0;


  // 誤差の計算
  err_curr_l = vel_ref_l - vel_curr_l;
  err_curr_r = vel_ref_r - vel_curr_r;
  err_sum_l += err_curr_l;
  err_sum_r += err_curr_r;
  
  err_curr_s = vel_ref_s - vel_curr_s;
  
  err_sum_s += err_curr_s;
 
 

  vari += abs(err_curr_l) + abs(err_curr_r);
  varian = vari / count;
  count ++;
  
  vari_s += abs(err_curr_s) + abs(err_curr_s);
  varian_s = vari_s / count_s;
  counts ++;

  
 

  // PID制御
  pwm_l = Kp * err_curr_l + Ki * err_sum_l + Kd * (err_curr_l - err_prev_l);
  pwm_r = Kp * err_curr_r + Ki * err_sum_r + Kd * (err_curr_r - err_prev_r);
 pwm_s = Kp_s * err_curr_s + Ki_s * err_sum_s + Kd_s * (err_curr_s - err_prev_s);
  
  // 速度指令値 = 0 なら強制的に停止
  if (vel_ref_l == 0.0) pwm_l = 0;
  if (vel_ref_r == 0.0) pwm_r = 0;
  

  motor_set(pwm_l, pwm_r);

  dist_prev_l = dist_curr_l;
  dist_prev_r = dist_curr_r;
  err_prev_l  = err_curr_l;
  err_prev_r  = err_curr_r;
  
  
  if (vel_ref_s == 0.0) pwm_s = 0;
  
  motor_set_s(pwm_s);

  dist_prev_s = dist_curr_s;
 
  err_prev_s  = err_curr_s;
  
 
  
}



void vel_ctrl_set(double vel_l, double vel_r) {
  vel_ref_l = vel_l;
  vel_ref_r = vel_r;
}

void vel_ctrl_set_s(double vel_s) {
  vel_ref_s = vel_s;
}

void vel_ctrl_get(double *vel_l, double *vel_r) {
  *vel_l = vel_curr_l;
  *vel_r = vel_curr_r;
}

void vel_ctrl_get_s(double *vel_s) {
  *vel_s = vel_curr_s;
  
}

void vel_ctrl_get_vari(double *variance) {
  *variance = varian;
}

void vel_ctrl_get_vari_s(double *variance_s) {
  *variance_s = varian_s;
}


void vel_ctrl_reset() {
  dist_prev_l = 0.0;
  dist_prev_r = 0.0;
  err_prev_l  = 0.0;
  err_prev_r  = 0.0;
  err_sum_l   = 0.0;
  err_sum_r   = 0.0;
  vel_ref_l   = 0.0;
  vel_ref_r   = 0.0;

  motor_set(0, 0);
  encoder_reset();
}

void vel_ctrl_reset_s() {
  dist_prev_s = 0.0;
  
  err_prev_s  = 0.0;
  
  err_sum_s  = 0.0;
 
  vel_ref_s   = 0.0;
  

  motor_set_s(0);
  encoder_reset_s();
}
